
	Disk Imploder V2.27 by A.J.Brouwer.  FreeWare
	---------------------------------------------


NAME
	DImp - Archives cylinders.


SYNOPSIS
	DImp READ <SourceDrive> Ca[-Cb,Cc,..] <TargetFile> [-M?|-NB|-NC|-X] [+Readme]
	  The collection of cylinders to be read must be specified by ranges, Ca-Cb,
	  and/or single cylinders, separated by commas.
	  -M? or MODE?    = Compression mode, ? = 0-7, default = 5
	  -NB or NOBITMAP = Ignore bitmap (normally unused blocks are cleared)
	  -NC or NOCOMP   = Do not compress cylinders
	  -X  or EXE      = Create self-extracting overlayed executable
	  +"Name of Readme file to be displayed during WRITE"
	DImp WRITE <DImpFile> <TargetDrive>
	DImp INFO <DImpFile>
	DImp ABOUT
	DImp will use ".dmp" or ".dex" filename extensions when trying to
	create or recognize DImp data files.


DESCRIPTION
	  DImp allows you to compress a subselection of cylinders from
	any floppy compatible device into a file.  DImp is fast and
	sports a good compression ratio.  Notably, DImp allows you to
	create a self extracting file with an appended readme text,
	thus providing you with a completely self-contained method of
	distributing a disk's contents in a file.

	   There are four operation mode keywords; "READ" specifies
	that cylinders must be read, "WRITE" indicates that you wish to
	write cylinders encoded in a dimped file, "INFO" displays
	information about the contents of a file containing dimped
	cylinders, and "ABOUT" should be obvious.

	  The cylinders are individually compressed, checksummed and
	stored, thus, in case of a transmission error, valid cylinders
	can be undimped, and the originator can then select, dimp and
	retransmit the faulty cylinders.

	  The cylinders to be READ can be selected by entering cylinder
	numbers separated by commas, or a dash if you wish to specify
	a range of cylinders.

	  When reading or writing, DImp can handle any device that
	supports the normal floppy 2 heads 11 sectors etc. layout,
	thus it is usable with f.e a RAD: or an FMS disk.  You can omit
	the colon normally following these device names.

	  Additional options include compression mode selection override.
	Given the fact that the tracks are compressed individually, the
	default mode 5 has a pretty optimal compression ratio, though
	the ratio isn't as good as it might have been if cylinder data
	had been treated as a continuous stream.  This is a design choice
	intended to allow the aforementioned flexible handling of
	individual cylinders.

	  If there's sufficient free memory, DImp will allocate buffers
	for a turbo compression algorithm.  Also, reducing the crunch
	mode will speed things up, dramatically so if you don't have
	sufficient free memory for DImp to run in turbo mode.  Lowering
	the crunch modes results in less efficient compression though.

	  Next, there are a couple of option switches.  NOBITMAP
	prevents DImp from discarding data that, according to the disk's
	bitmap, isn't used by the filing system.  This option is rarely
	needed.  If you suspect a disk to contain a program that uses a
	low level routine to read its information from that disk, this
	option might be required to prevent loss of relevant data.
	NOCOMP disables compression.  EXE causes DImp to generate self
	extracting dimp files.  These can be executed, and will write
	their contents to a disk selected by the user.  Executable DImp
	files (.dex filename extension) can be treated as normal DImp
	files (.dmp filename extension) in that you can use DImp to
	WRITE these, or get INFO on them.

	  Lastly, you may specify a filename containing text to be
	displayed during the writing or self-extraction of the dimp file
	you're creating.  This allows you to include a fairly extensive
	comment on the contents of the disk.  This readme filename must
	follow a "+" commandline indicator.


EXAMPLES
	DImp READ rad 0-79 Work:Cylinders EXE +ram:blahblah


TECHNOCRAP
	  The self-extracting executable files generated by DImp are
	overlayed.  This allows for the cylinder data to be spooled
	during the self-extraction process, resulting in much more
	modest memory requirements than the size of the executable
	would lead one to suspect.

	  Thanks to resource tracking, transparent error management,
	modular algorithm linking, and sitting on the program for
	several years before releasing it, DImp should be very robust
	and return sensible error messages.

	DImp is pure and can be made resident.


AUTHOR
	Albert-Jan Brouwer 
	UUCP hp4nl.nluug.nl!cbmnlux!ecl001!ajbrouw
	UUCP cbmvax.commodore.com!cbmehq!cbmnlux!ecl001!ajbrouw
	FIDO: 2:281/614 (up for freq sometime fall '91)
